{#-#####################################################################
 # Interface indexes
 #----------------------------------------------------------------------
 # This template is invoked as an init task to process every interface
 # definition prior to configuration generation. Processed interfaces
 # are normalized, validated, and indexed. The results of this process
 # are echoed back as a dictionary of indexes, which is stored within
 # an Ansible fact for later use.
 ####################################################################-#}
{#-=====================================================================
 # Imports
 #===================================================================-#}
{#- Macros implementing operations on configuration data -#}
{%- import "inc/devices.j2"     as devices      with context -%}
{%- import "inc/validation.j2"  as validation   with context -%}

{#-=====================================================================
 # Global variables
 #===================================================================-#}
{#----------------------------------------------------------------------
 # Defaults
 #--------------------------------------------------------------------#}
{#- Skeleton data structure for network interfaces -#}
{%- set skeleton = role__sys_net_interfaces__interface_skeleton -%}

{#- Platform defaults -#}
{%- set defaults =
    role__sys_net_interfaces__platform_options['defaults'] -%}

{#----------------------------------------------------------------------
 # Indexes
 #--------------------------------------------------------------------#}
{#- This index maps each interface uid to validation results. -#}
{%- set index_validation_results = {} -%}

{#- This index maps the uid of each valid interface to an interface
 #  definition. -#}
{%- set index_valid_interfaces = {} -%}

{#- This index maps each interface uid to a native device name for the
 #  interface on the targeted platform. -#}
{%- set index_native_device_names = {} -%}

{#- This index maps each interface uid to the final device name of the
 #  interface after interface renaming rules are applied. -#}
{%- set index_final_device_names = {} -%}

{#-=====================================================================
 # Pre-tasks
 # ---------------------------------------------------------------------
 # Normalize and validate network interface definitions, then build
 # indexes.
 #===================================================================-#}
{%- for interface in my_sys_net_interfaces -%}
  {#--------------------------------------------------------------------
   # Validate and normalize
   #------------------------------------------------------------------#}
  {#- Normalize interface definition -#}
  {%- set interface = validation.normalize_definition(
      interface, skeleton, defaults) | from_json -%}

  {#- Validate interface structure -#}
  {%- set validation_results =
      validation.validate_interface(interface) | from_json -%}

  {#--------------------------------------------------------------------
   # If the interface is valid, update indexes
   #------------------------------------------------------------------#}
  {%- if validation_results.is_valid | bool -%}
    {#- Valid interfaces -#}
    {{
      index_valid_interfaces.update({
        interface['uid']: interface
      })
    }}

    {#- Native device name -#}
    {{
      index_native_device_names.update({
        interface['uid']:
          devices.generate_interface_native_device_name(interface)
      })
    }}

    {#- Final device name -#}
    {{
      index_final_device_names.update({
        interface['uid']:
          devices.generate_interface_final_device_name(interface)
      })
    }}
  {%- endif -%}

  {#- Validation results index is updated whatever happens -#}
  {{
    index_validation_results.update({
      interface['uid']: validation_results
    })
  }}
{%- endfor -%}

{#-=====================================================================
 # Rendering
 # ---------------------------------------------------------------------
 # Render interface configuration in the specified format
 #===================================================================-#}

{#- Return all indexes consolidated as a dict -#}
{{
  {
    'validation_results':   index_validation_results,
    'valid_interfaces':     index_valid_interfaces,
    'native_device_names':  index_native_device_names,
    'final_device_names':   index_final_device_names
  }
}}
